/*
 * Copyright 1991 Addison-Wesley Publishing Company
 *                (see the file "COPYRIGHTS" for details)
 */

/* includes */
#include <Xm/Xm.h>
#include <X11/Shell.h>

/* HACK because Protocols.h erroneously depends on a private header file */
#define XA_WM_PROTOCOLS XmInternAtom(XtDisplay(toplevel),"WM_PROTOCOLS",FALSE)
/* !!!IMPORTANT!!! */
#include <X11/Protocols.h>

#include "IconBox.h"

/* global definitions */

#define PROGRAM_CLASS "IconBox"
#define ERROR_CLASS   "IconBoxError"

#define NUM_ARGS 10

/* error definitions */

#define NErrCannotOpen "cannotOpen"
#define TErrMain       "Main"

/******************************/

void EndProgram (widget, client_data, call_data)
    Widget        widget;
    caddr_t       client_data;
    caddr_t       call_data;
{
    SaveIconBox ((Widget) client_data);
    exit (0);
}

void main (argc, argv)
    unsigned int    argc;
    char          **argv;
{
    Display        *display;
    XtAppContext    ac;
    Arg             args[NUM_ARGS];
    Widget          toplevel, box;

    /* init toolkit */
    XtToolkitInitialize();
    ac = XtCreateApplicationContext();
    display = XtOpenDisplay (
                  ac,          /* application context = default */
                  NULL,        /* use DISPLAY from environment  */
                  NULL,        /* use last of argv[0] as name   */
                  PROGRAM_CLASS,
                  NULL,        /* no additional cmd line options*/
                  0,           /* ditto                         */
                  &argc,
                  argv);       /* use and delete std options    */

    if (display == NULL)       /* necessary !                   */
        XtErrorMsg (
            NErrCannotOpen, TErrMain,  /* resource name         */
            ERROR_CLASS,               /* resource class        */
            "cannot open display",     /* default message       */
            NULL, NULL);               /* parameters            */

    /* create application shell */
    XtSetArg (args[0], XmNallowShellResize, True);
    XtSetArg (args[1], XmNdeleteResponse, XmDO_NOTHING);
    toplevel = XtAppCreateShell (
                   NULL,               /* use same program name */
                   PROGRAM_CLASS,      /* repeat class param    */
                   applicationShellWidgetClass,
                   display,
                   args, 2);           /* argument list         */

    /* create main window */
    box = CreateIconBox (toplevel, args, 0);

    XmAddWMProtocolCallback (toplevel, 
                             XmInternAtom (display, "WM_DELETE_WINDOW", True),
                             EndProgram, (caddr_t) box);
    /* start loop */
    XtRealizeWidget (toplevel);
    XtAppMainLoop (ac);
}

